package com.example.myveryownapplication;

import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Intent;
import java.util.UUID;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Random;

import java.io.IOException;
import java.util.Set;

public class MainActivity extends AppCompatActivity {

    private TextView mainView;
    private TextView secondView;
    private StringBuilder consoleText;
    private StringBuilder consoleText2;

    private BluetoothAdapter mBluetoothAdapter;
    static final UUID myUUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");
    private BluetoothSocket mmSocket;
    private BluetoothDevice mmDevice;

    private OutputStream mmOutputStream;
    private InputStream mmInputStream;

    private Thread workerThread;
    private byte[] readBuffer;
    private int readBufferPosition;
    private int counter;
    volatile boolean stopWorker;

    char flagA, flagB, flagC, flagD, flagE, flagF, flagG;
    char flag1, flag2, flag3, flag4, flag5, flag6, flag7, flag8, flag9;

    private String messageReceived;

    private GameMenu gameMenu;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        consoleText = new StringBuilder();
        consoleText2 = new StringBuilder();

        mainView = findViewById(R.id.tv_composer2);
        secondView = findViewById(R.id.tv_composer);

        Button testBut = (Button) findViewById(R.id.button);
        testBut.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                //Afisam pe MainView:
                consoleText2.append("->Trimitem un mesaj:ABCD" + "\n");
                secondView.setText(consoleText2);
                try {
                    char sh = 0b01111111;
                    String s = String.valueOf(sh);
                    sendData(s);
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });

        Button testBut2 = (Button) findViewById(R.id.button2);
        testBut2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                consoleText2.append("->Trimitem un mesaj:FGHI" + "\n");
                secondView.setText(consoleText2);
                try {
                    sendData("FGHI");
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });

        Button resetBt = (Button) findViewById(R.id.reset);
        resetBt.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                //Afisam pe MainView:
                consoleText2.append("->Jocul a fost resetat" + "\n");
                secondView.setText(consoleText2);

                findBT();
                try {
                    openBT();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                messageReceived = new String("EMPTY");

                flag1 = flag2 = flag3 = flag4 = flag5 = flag6 = flag7 = flag8 = flag9 = 0;
                flagA = flagB = flagC = flagD = flagE = flagF = flagG = 0;

                GameMenu gameMenu = new GameMenu();
                gameMenu.start();
            }
        });

    }

    ////////////////////////////////
    //#######BLUETOOTHFUNCTIONS#####

    void findBT() {
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
        if (mBluetoothAdapter == null) {
            consoleText2.append("->Niciun dispozitiv bluetooth disponibil" + "\n");
            secondView.setText(consoleText2);
        }

        if (!mBluetoothAdapter.isEnabled()) {
            Intent enableBluetooth = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(enableBluetooth, 0);
        }

        Set<BluetoothDevice> pairedDevices = mBluetoothAdapter.getBondedDevices();
        if (pairedDevices.size() > 0) {
            for (BluetoothDevice device : pairedDevices) {
                if (device.getName().equals("HC-05")) {
                    consoleText2.append("->Dispozitivul HC-05 a fost gasit" + "\n");
                    secondView.setText(consoleText2);
                    mmDevice = device;
                    break;
                }
            }
        }
        consoleText2.append("->Functia findBT s-a terminat cu succes" + "\n");
        secondView.setText(consoleText2);
    }

    void openBT() throws IOException {
        if (mmDevice != null) {
            mmSocket = mmDevice.createRfcommSocketToServiceRecord(myUUID);
            try {
                mmSocket.connect();
            } catch (IOException ex) {
                consoleText2.append("->Eroare connect" + "\n");
                secondView.setText(consoleText2);
            }
            mmOutputStream = mmSocket.getOutputStream();
            mmInputStream = mmSocket.getInputStream();

            beginListenForData();

            consoleText2.append("->Bluetooth deschis" + "\n");
            secondView.setText(consoleText2);
        } else {
            consoleText2.append("->mmDevice este null" + "\n");
            secondView.setText(consoleText2);
        }
    }

    void beginListenForData() {
        final Handler handler = new Handler();
        final byte delimiter = 78; //This is the ASCII code for a newline character

        stopWorker = false;
        readBufferPosition = 0;
        readBuffer = new byte[1024];
        workerThread = new Thread(new Runnable() {
            public void run() {
                while (!Thread.currentThread().isInterrupted() && !stopWorker) {
                    try {
                        int bytesAvailable = mmInputStream.available();
                        if (bytesAvailable > 0) {
                            byte[] packetBytes = new byte[bytesAvailable];
                            mmInputStream.read(packetBytes);
                            for (int i = 0; i < bytesAvailable; i++) {
                                byte b = packetBytes[i];
                                if (b == delimiter) {
                                    byte[] encodedBytes = new byte[readBufferPosition];
                                    System.arraycopy(readBuffer, 0, encodedBytes, 0, encodedBytes.length);
                                    final String data = new String(encodedBytes, "US-ASCII");
                                    messageReceived = data;
                                    readBufferPosition = 0;
                                    {
                                        if (data.equals("A")) {
                                            flagA = 1;
                                        }
                                        if (data.equals("B")) {
                                            flagB = 1;
                                        }
                                        if (data.equals("C")) {
                                            flagC = 1;
                                        }
                                        if (data.equals("D")) {
                                            flagD = 1;
                                        }
                                        if (data.equals("E")) {
                                            flagE = 1;
                                        }
                                        if (data.equals("F")) {
                                            flagF = 1;
                                        }
                                        if (data.equals("G")) {
                                            flagG = 1;
                                        }
                                        if (data.equals("H")) {
                                            flag1 = 1;
                                        }
                                        if (data.equals("I")) {
                                            flag2 = 1;
                                        }
                                        if (data.equals("J")) {
                                            flag3 = 1;
                                        }
                                        if (data.equals("K")) {
                                            flag4 = 1;
                                        }
                                        if (data.equals("L")) {
                                            flag5 = 1;
                                        }
                                        if (data.equals("M")) {
                                            flag6 = 1;
                                        }
                                        if (data.equals("Q")) {
                                            flag7 = 1;
                                        }
                                        if (data.equals("O")) {
                                            flag8 = 1;
                                        }
                                        if (data.equals("P")) {
                                            flag9 = 1;
                                        }
                                    }
                                    Log.i("BL", "###Mesaj primit: " + messageReceived);

                                    MainActivity.this.runOnUiThread(new Runnable() {
                                        public void run() {
                                            consoleText2.append("->[P]Mesaj primit: |" + data + "|\n");
                                            secondView.setText(consoleText2);
                                        }
                                    });
                                } else {
                                    readBuffer[readBufferPosition++] = b;
                                }
                            }
                        }
                    } catch (IOException ex) {
                        stopWorker = true;
                    }
                }
            }
        });

        workerThread.start();
    }

    void sendData(String msg) throws IOException {

        if (mmSocket != null) {
            try {
                msgSecondView("->[T]Mesaj trimis: |" + String.valueOf((int)msg.getBytes()[0]) + "|" + String.valueOf((int)msg.getBytes()[0]) +"|"+ String.valueOf((int)msg.getBytes()[0]) + "|\n");
                mmSocket.getOutputStream().write(msg.getBytes());
            } catch (IOException e) {
                msg("Error writing to socket");
            }
        }
    }

    ////////////////////////////////
    ////////////////////////////////

    class GameMenu extends Thread {

        char[][] table;
        char player1;
        char player2;

        int scor1;
        int scor2;

        char row1 = 0b00000000;
        char row2 = 0b00000000;
        char row3 = 0b00000000;

        public GameMenu() {

            consoleText.append("->Incepe o noua sesiune de joc" + "\n");
            mainView.setText(consoleText);

            scor1 = scor2 = 0;

            MainActivity.this.runOnUiThread(new Runnable() {
                public void run() {
                    mainView.setText("Scor: Player1: " + String.valueOf(scor1) + "\n" +
                            "      Player2: " + String.valueOf(scor2));
                }
            });

            table = new char[3][3];

            for (int i = 0; i < 3; i++) {
                for (int j = 0; j < 3; j++) {
                    table[i][j] = '1';
                }
            }

        }

        public void run() {

            //Meniul jocului:
            //Optiuni
            while (true) {
                //Joc Player vs Player
                if (flagA == 1) {
                    Log.i("PP", "Meci Player vs Player");
                    msgSecondView("->Meci selectat: Player vs Player\n");
                    try {
                        sendData(String.valueOf(row1) + String.valueOf(row2) + String.valueOf(row3));
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                    flagA = 0;

                    while (flagA == 0 && flagB == 0) {
                    }
                    ;

                    if (flagA == 1) {
                        player1 = 'X';
                        player2 = 'O';
                        flagA = 0;
                        Log.i("Joc", "Jucatorul1 este X");
                        msgSecondView("->Jocatorul 1 este X(Albastru)\n" +
                                "->Jucatorul 2 este O(Verde)\n");
                    }
                    if (flagB == 1) {
                        player1 = 'O';
                        player2 = 'X';
                        flagB = 0;
                        Log.i("Joc", "Jucatorul1 este O");
                        msgSecondView("->Jucatorul 2 este O(Verde)\n" +
                                "->Jucatorul 2 este X(Albastru)\n");
                    }
                    try {
                        sendData(String.valueOf(row1) + String.valueOf(row2) + String.valueOf(row3));
                    } catch (IOException e) {
                        e.printStackTrace();
                    }

                    char turn = 1; // 1 = X // 0 = O;

                    Log.i("J1", "Jucatorul1 adauga:");
                    msgSecondView("Jucatorul 1 trebuie sa adauge:\n");

                    //Aici incepe jocul:
                    while (true) {

                        while (flag1 == 0 && flag2 == 0 && flag3 == 0 && flag4 == 0 && flag5 == 0 &&
                                flag6 == 0 && flag7 == 0 && flag8 == 0 && flag9 == 0) {
                        }
                        ;

                        char curFlag = seeFlag();

                        if (turn == 1) {
                            Log.i("J1", "Jucatorul2 adauga:");
                            msgSecondView("Jucatorul 2 trebuie sa adauge:\n");
                            if (addElem(curFlag, player1) == true) {
                                turn = 3;
                            }

                        }
                        if (turn == 0) {
                            Log.i("J1", "Jucatorul1 adauga:");
                            msgSecondView("Jucatorul 1 trebuie sa adauge:\n");
                            if (addElem(curFlag, player2) == true) {
                                turn = 4;
                            }
                        }
                        resetFlags();
                        try {
                            sendData(String.valueOf(row1) + String.valueOf(row2) + String.valueOf(row3));
                        } catch (IOException e) {
                            e.printStackTrace();
                        }
                        if (turn == 3) {
                            turn = 0;
                        }
                        if (turn == 4) {
                            turn = 1;
                        }
                        char v = checkWin();
                        if (v != 0) {
                            Log.i("JocTerminat", "Jocul s-a terminat");
                            //Updatam scorul
                            if (v == player1) {
                                scor1++;
                            } else {
                                scor2++;
                            }
                            MainActivity.this.runOnUiThread(new Runnable() {
                                public void run() {
                                    mainView.setText("Scor: Player1: " + String.valueOf(scor1) + "\n" +
                                            "      Player2: " + String.valueOf(scor2));
                                    //consoleText2.append("->Meciul s-a terminat\n" +
                                     //       "->Inapoi la meniul principal\n");
                                    //secondView.setText(consoleText2);
                                    msgSecondView("->Meciul s-a terminat\n" +
                                            "->Inapoi la meniul principal\n");
                                }
                            });
                            row1 = row2 = row3 = 0b00000000;
                            resetTable();
                            break;
                        } else {
                            Log.i("JocTerminat", "Jocul nu s-a terminat");
                            if(checkDraw() == true){
                                mainView.setText("Scor: Player1: " + String.valueOf(scor1) + "\n" +
                                        "      Player2: " + String.valueOf(scor2));
                                row1 = row2 = row3 = 0b00000000;
                                resetTable();
                                break;
                            }
                        }

                    }

                }
                if (flagB == 1) {
                    Log.i("PP", "Meci Player vs AI");
                    msgSecondView("->Meci selectat: Player vs AI\n");
                    msgSecondView("->Meci selectat: Player vs Player\n");
                    try {
                        sendData(String.valueOf(row1) + String.valueOf(row2) + String.valueOf(row3));
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                    flagB = 0;

                    while (flagA == 0 && flagB == 0) {
                    }
                    ;

                    if (flagA == 1) {
                        player1 = 'X';
                        player2 = 'O';
                        flagA = 0;
                        Log.i("Joc", "Jucatorul1 este X");
                        msgSecondView("->Jocatorul 1 este X(Albastru)\n" +
                                "->Jucatorul 2 este O(Verde)\n");
                    }
                    if (flagB == 1) {
                        player1 = 'O';
                        player2 = 'X';
                        flagB = 0;
                        Log.i("Joc", "Jucatorul1 este O");
                        msgSecondView("->Jucatorul 2 este O(Verde)\n" +
                                "->Jucatorul 2 este X(Albastru)\n");
                    }
                    try {
                        sendData(String.valueOf(row1) + String.valueOf(row2) + String.valueOf(row3));
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                    char turn = 1; // 1 = X // 0 = O;

                    Log.i("J1", "Jucatorul1 adauga:");
                    msgSecondView("Jucatorul 1 trebuie sa adauge:\n");

                    //Aici incepe jocul:
                    while (true) {

                        while (flag1 == 0 && flag2 == 0 && flag3 == 0 && flag4 == 0 && flag5 == 0 &&
                                flag6 == 0 && flag7 == 0 && flag8 == 0 && flag9 == 0) {
                        }
                        ;

                        char curFlag = seeFlag();

                        if (turn == 1) {
                            Log.i("J1", "AI adauga:");
                            msgSecondView("AI trebuie sa adauge:\n");
                            if (addElem(curFlag, player1) == true) {
                                turn = 0;
                            }

                        }
                        char v = checkWin();
                        if (turn == 0) {
                            Log.i("J1", "Jucatorul1 adauga:");
                            msgSecondView("Jucatorul 1 trebuie sa adauge:\n");

                            Random rand = new Random();
                            int move = rand.nextInt();
                            char cmove = (char)((char)(move) + 48);

                            while(v == 0 && addElem(cmove, player2) != true) {
                                move = rand.nextInt();
                                cmove = (char)((char)(move) + 48);
                            }
                            turn = 1;
                        }
                        resetFlags();
                        try {
                            sendData(String.valueOf(row1) + String.valueOf(row2) + String.valueOf(row3));
                        } catch (IOException e) {
                            e.printStackTrace();
                        }
                        if (v != 0) {
                            Log.i("JocTerminat", "Jocul s-a terminat");
                            //Updatam scorul
                            if (v == player1) {
                                scor1++;
                            } else {
                                scor2++;
                            }
                            MainActivity.this.runOnUiThread(new Runnable() {
                                public void run() {
                                    mainView.setText("Scor: Player1: " + String.valueOf(scor1) + "\n" +
                                            "      Player2: " + String.valueOf(scor2));
                                    msgSecondView("->Meciul s-a terminat\n" +
                                            "->Inapoi la meniul principal\n");
                                }
                            });
                            row1 = row2 = row3 = 0b00000000;
                            resetTable();
                            break;
                        } else {
                            Log.i("JocTerminat", "Jocul nu s-a terminat");
                            if(checkDraw() == true){
                                mainView.setText("Scor: Player1: " + String.valueOf(scor1) + "\n" +
                                        "      Player2: " + String.valueOf(scor2));
                                row1 = row2 = row3 = 0b00000000;
                                resetTable();
                                break;
                            }
                        }

                    }

                }
                if (flagC == 1) {
                    try {
                        sendData(String.valueOf(row1) + String.valueOf(row2) + String.valueOf(row3));
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                    flagC = 0;
                }
                if (seeFlag() != 1) {
                    try {
                        sendData(String.valueOf(row1) + String.valueOf(row2) + String.valueOf(row3));
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                    resetFlags();
                }
            }

        }

        private int[] convertMove(char flag) {
            int[] pos = new int[2];

            if (flag == '1') {
                pos[0] = 0;
                pos[1] = 0;
            }
            if (flag == '2') {
                pos[0] = 0;
                pos[1] = 1;
            }
            if (flag == '3') {
                pos[0] = 0;
                pos[1] = 2;
            }
            if (flag == '4') {
                pos[0] = 1;
                pos[1] = 0;
            }
            if (flag == '5') {
                pos[0] = 1;
                pos[1] = 1;
            }
            if (flag == '6') {
                pos[0] = 1;
                pos[1] = 2;
            }
            if (flag == '7') {
                pos[0] = 2;
                pos[1] = 0;
            }
            if (flag == '8') {
                pos[0] = 2;
                pos[1] = 1;
            }
            if (flag == '9') {
                pos[0] = 2;
                pos[1] = 2;
            }

            return pos;
        }

        private boolean addElem(char pos, char player) {
            int[] vect = new int[2];
            vect = convertMove(pos);

            Log.i("addElem", "convertMove:" + String.valueOf(vect[0]) + " " + String.valueOf(vect[1]));

            //Loc valid:
            if (table[vect[0]][vect[1]] == '1') {
                table[vect[0]][vect[1]] = player;
                if (vect[0] == 0) {
                    if (vect[1] == 0) {
                        Log.i("addElem", "R1 C1");
                        if (player == 'X') {
                            Log.i("addElem", "X");
                            row1 = (char) (row1 | 0b01000000);
                            Log.i("Val",String.valueOf((int)(row1)));
                        } else {
                            Log.i("addElem", "O");
                            row1 = (char) (row1 | 0b00100000);
                            Log.i("Val",String.valueOf((int)(row1)));
                        }
                    }
                    if (vect[1] == 1) {
                        Log.i("addElem", "R1 C2");
                        if (player == 'X') {
                            Log.i("addElem", "X");
                            row1 = (char) (row1 | 0b00010000);
                        } else {
                            Log.i("addElem", "O");
                            row1 = (char) (row1 | 0b00001000);
                        }
                    }
                    if (vect[1] == 2) {
                        Log.i("addElem", "R1 C3");
                        if (player == 'X') {
                            Log.i("addElem", "X");
                            row1 = (char) (row1 | 0b00000100);
                        } else {
                            Log.i("addElem", "O");
                            row1 = (char) (row1 | 0b00000010);
                        }
                    }
                }
                if (vect[0] == 1) {
                    if (vect[1] == 0) {
                        Log.i("addElem", "R2 C1");
                        if (player == 'X') {
                            Log.i("addElem", "X");
                            row2 = (char) (row2 | 0b01000000);
                        } else {
                            Log.i("addElem", "O");
                            row2 = (char) (row2 | 0b00100000);
                        }
                    }
                    if (vect[1] == 1) {
                        Log.i("addElem", "R2 C2");
                        if (player == 'X') {
                            Log.i("addElem", "X");
                            row2 = (char) (row2 | 0b00010000);
                        } else {
                            Log.i("addElem", "O");
                            row2 = (char) (row2 | 0b00001000);
                        }
                    }
                    if (vect[1] == 2) {
                        Log.i("addElem", "R2 C3");
                        if (player == 'X') {
                            Log.i("addElem", "X");
                            row2 = (char) (row2 | 0b00000100);
                        } else {
                            Log.i("addElem", "O");
                            row2 = (char) (row2 | 0b00000010);
                        }
                    }

                }
                if (vect[0] == 2) {
                    if (vect[1] == 0) {
                        Log.i("addElem", "R3 C1");
                        if (player == 'X') {
                            Log.i("addElem", "X");
                            row3 = (char) (row3 | 0b01000000);
                        } else {
                            Log.i("addElem", "O");
                            row3 = (char) (row3 | 0b00100000);
                        }
                    }
                    if (vect[1] == 1) {
                        Log.i("addElem", "R3 C2");
                        if (player == 'X') {
                            Log.i("addElem", "X");
                            row3 = (char) (row3 | 0b00010000);
                        } else {
                            Log.i("addElem", "O");
                            row3 = (char) (row3 | 0b00001000);
                        }
                    }
                    if (vect[1] == 2) {
                        Log.i("addElem", "R3 C3");
                        if (player == 'X') {
                            Log.i("addElem", "X");
                            row3 = (char) (row3 | 0b00000100);
                        } else {
                            Log.i("addElem", "O");
                            row3 = (char) (row3 | 0b00000010);
                        }
                    }
                }
                return true;
            } else {
                Log.i("addElem", "Loc invalid");
                return false;
            }
        }

        private char seeFlag() {
            if (flag1 == 1) {
                return '1';
            }
            if (flag2 == 1) {
                return '2';
            }
            if (flag3 == 1) {
                return '3';
            }
            if (flag4 == 1) {
                return '4';
            }
            if (flag5 == 1) {
                return '5';
            }
            if (flag6 == 1) {
                return '6';
            }
            if (flag7 == 1) {
                return '7';
            }
            if (flag8 == 1) {
                return '8';
            }
            if (flag9 == 1) {
                return '9';
            }
            return 1;
        }

        private void resetFlags() {
            flag1 = flag2 = flag3 = flag4 = flag5 = flag6 = flag7 = flag8 = flag9 = 0;
        }

        private char checkWin() {
            if (table[0][0] == table[0][1] && table[0][1] == table[0][2] && table[0][0] != '1' ||
                    table[1][0] == table[1][1] && table[1][1] == table[1][2] && table[1][0] != '1' ||
                    table[2][0] == table[2][1] && table[2][1] == table[2][2] && table[2][0] != '1') {
                //Victorie pe linie:
                Log.i("Victorie", "Victorie pe linie");
                if (table[0][0] == table[0][1] && table[0][0] != '1') {
                    return table[0][0];
                }
                if (table[1][0] == table[1][1] && table[1][0] != '1') {
                    return table[1][0];
                }
                if (table[2][0] == table[2][1] && table[2][0] != '1') {
                    return table[2][0];
                }
                return 0;
            }
            if (table[0][0] == table[1][0] && table[1][0] == table[2][0] && table[0][0] != '1' ||
                    table[0][1] == table[1][1] && table[1][1] == table[2][1] && table[0][1] != '1' ||
                    table[0][2] == table[1][2] && table[1][2] == table[2][2] && table[0][2] != '1') {
                //Victorie pe coloana:
                Log.i("Victorie", "Victorie pe coloana");
                if (table[0][0] == table[1][0] && table[0][0] != '1') {
                    return table[0][0];
                }
                if (table[0][1] == table[1][1] && table[0][1] != '1') {
                    return table[0][1];
                }
                if (table[0][2] == table[1][2] && table[0][2] != '1') {
                    return table[0][2];
                }
                return 0;
            }
            if (table[0][0] == table[1][1] && table[1][1] == table[2][2] && table[0][0] != '1' ||
                    table[2][0] == table[1][1] && table[1][1] == table[0][2] && table[2][0] != '1') {
                //Victorie pe diagonala:
                Log.i("Victorie", "Victorie pe diagonala");
                if (table[0][0] == table[1][1] && table[0][0] != '1') {
                    return table[0][0];
                }
                if (table[2][0] == table[1][1] && table[2][0] != '1') {
                    return table[2][0];
                }
                return 0;
            }
            Log.i("Egalitate", "Jocul nu s-a terminat");
            return 0;
        }
        private  boolean checkDraw(){
            for(int i = 0; i < 3; i++){
                for(int j = 0; j < 3; j++){
                    if(table[i][j] == '1'){
                        return false;
                    }
                }
            }
            return true;
        }

        private void resetTable(){

            for (int i = 0; i < 3; i++){
                for (int j = 0; j < 3; j++){
                    table[i][j] = '1';
                }
            }

        }

    }

    private void msg(String s) {
        Toast.makeText(getApplicationContext(), s, Toast.LENGTH_LONG).show();
    }

    private void msgSecondView(final String s){
    MainActivity.this.runOnUiThread(new Runnable() {
        public void run () {
            consoleText2.append(s);
            secondView.setText(consoleText2);
        }
    });
}
}
